using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.SharePoint;

namespace ListHierarchy
{
    class Program
    {
        static void Main(string[] args)
        {
            SPSite site = new SPSite("http://win2k3r2lab");
            SPWeb web = site.AllWebs["SiteDirectory/research"];
            SPList parentList = web.Lists["Hierarchy Demo"];

            foreach (SPListItem order in parentList.Folders)
            {
                Console.WriteLine("Order        : {0}",order["Name"]);
                Console.WriteLine("Order Number : {0}", order["Order Number"]);

                SPQuery orderItemsQuery = new SPQuery();
                orderItemsQuery.Folder = order.Folder;
                SPListItemCollection orderItems = parentList.GetItems(orderItemsQuery);
                foreach (SPListItem orderItem in orderItems)
                {
                    Console.WriteLine("\tLine Item {0}: {1} {2}",
                        orderItem["OrderItem"],
                        orderItem["SKU"],
                        orderItem["Title"]);
                }                    

            }

            Console.ReadLine();
        }
    }
}
