using System;
using System.Collections.Generic;
using System.Text;

using Microsoft.SharePoint.Administration;
using Microsoft.Office.Server.ApplicationRegistry.Administration;
using Microsoft.Office.Server.Administration;
using Microsoft.Office.Server.ApplicationRegistry.Infrastructure;
using System.IO;
using System.Xml;

namespace BDCAdmin
{
    class Program
    {
        static void Main(string[] args)
        {
            SqlSessionProvider.Instance().SetSharedResourceProviderToUse("SharedServices1");
            LobSystem system = 
                ApplicationRegistry.Instance.LobSystems.Create(
                  "BugSystemFromCode", true, 
                  "Microsoft.Office.Server.ApplicationRegistry.SystemSpecific.Db.DbSystemUtility", 
                  "Microsoft.Office.Server.ApplicationRegistry.SystemSpecific.Db.DbConnectionManager",
                  "Microsoft.Office.Server.ApplicationRegistry.SystemSpecific.Db.DbEntityInstance");

            LobSystemInstance sysInstance = 
                system.LobSystemInstances.Create("BugSystemFromCode", true);

            sysInstance.Properties.Add("AuthenticationMode", 
                (Int32)Microsoft.Office.Server.ApplicationRegistry.SystemSpecific.Db.DbAuthenticationMode.PassThrough);

            sysInstance.Properties.Add("DatabaseAccessProvider", 
                (Int32)Microsoft.Office.Server.ApplicationRegistry.SystemSpecific.Db.DbAccessProvider.SqlServer);

            sysInstance.Properties.Add("RdbConnection Data Source", @"win2k3r2lab\officeservers");
            sysInstance.Properties.Add("RdbConnection Initial Catalog", "CustomerData");
            sysInstance.Properties.Add("RdbConnection Integrated Security", "SSPI");
            sysInstance.Properties.Add("RdbConnection Pooling", "false");

            sysInstance.Properties.Add("WildCardCharacter", "%");
            sysInstance.Update();

            Entity bugEntity = system.Entities.Create("Bug", true, 10000);
            bugEntity.Properties.Add("Title", "Title"); // title property in list is title column in DB
            bugEntity.Identifiers.Create("BugID", true, "System.Int32");
            bugEntity.Update();

            Console.WriteLine("Bugentity created.");
            Console.ReadLine();
        }
    }
}
