using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Office.Server.ApplicationRegistry.MetadataModel;
using Microsoft.Office.Server.ApplicationRegistry.Runtime;
using Microsoft.Office.Server.ApplicationRegistry.SystemSpecific;
using Microsoft.Office.Server.ApplicationRegistry.Infrastructure;
using Microsoft.SharePoint.Administration;
using Microsoft.Office.Server.Administration;

namespace ExecuteFinder
{
    class Program
    {
        static void Main(string[] args)
        {
            SqlSessionProvider.Instance().SetSharedResourceProviderToUse("SharedServices1");
            NamedLobSystemInstanceDictionary sysInstances = ApplicationRegistry.GetLobSystemInstances();
            LobSystemInstance advWorksInstance = 
                sysInstances["AdventureWorksSampleInstance"];
            Entity custEntity = advWorksInstance.GetEntities()["Customer"];
            FilterCollection fc = custEntity.GetFinderFilters();
            Console.WriteLine("Customer Filters Available:");
            foreach (FilterBase filter in fc)
            {
                Console.WriteLine("\t" + filter.Name);
            }
            custEntity.FindFiltered(fc, advWorksInstance);
            
            
            IEntityInstanceEnumerator custEntityInstanceEnumerator = 
                custEntity.FindFiltered(fc, advWorksInstance);
            // runs through the entire DB, providing ID and Name (the two potential fields on
            // which to filter
            while (custEntityInstanceEnumerator.MoveNext())
            {
                IEntityInstance entityInstance = custEntityInstanceEnumerator.Current;
                foreach (Field f in custEntity.GetFinderView().Fields)
                    Console.Write("{0} ", entityInstance[f]);
                Console.WriteLine("");
            }

            Console.ReadLine();
        }
    }
}
