using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Office.Server.ApplicationRegistry.MetadataModel;
using Microsoft.Office.Server.ApplicationRegistry.Runtime;
using Microsoft.Office.Server.ApplicationRegistry.SystemSpecific;
using Microsoft.Office.Server.ApplicationRegistry.Infrastructure;
using Microsoft.SharePoint.Administration;
using Microsoft.Office.Server.Administration;

namespace ExecuteMethod
{
    class Program
    {
        static void Main(string[] args)
        {
            SqlSessionProvider.Instance().SetSharedResourceProviderToUse("SharedServices1");
            NamedLobSystemInstanceDictionary sysInstances = ApplicationRegistry.GetLobSystemInstances();
            LobSystemInstance advWorksInstance = 
                sysInstances["AdventureWorksSampleInstance"];
            Entity custEntity = advWorksInstance.GetEntities()["Customer"];
            MethodInstance methodInstance = custEntity.GetFinderMethodInstance();
            Object[] methodArgs = methodInstance.GetMethod().CreateDefaultParameterInstances(methodInstance);
            methodArgs[0] = 1760;
            methodArgs[1] = 1760;
            IEntityInstanceEnumerator custEntityInstanceEnumerator =
                (IEntityInstanceEnumerator)
                custEntity.Execute(methodInstance, advWorksInstance, ref methodArgs);
            while (custEntityInstanceEnumerator.MoveNext())
            {
                IEntityInstance entityInstance = 
                    custEntityInstanceEnumerator.Current;
                foreach (Field f in custEntity.GetFinderView().Fields)
                    Console.Write("{0} ", entityInstance[f]);
                Console.WriteLine("");
            }
            Console.Read();
        }
    }
}
