using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Office.Server.ApplicationRegistry.MetadataModel;
using Microsoft.Office.Server.ApplicationRegistry.Runtime;
using Microsoft.Office.Server.ApplicationRegistry.SystemSpecific;
using Microsoft.Office.Server.ApplicationRegistry.Infrastructure;
using Microsoft.SharePoint.Administration;
using Microsoft.Office.Server.Administration;
using System.Data;


namespace GetMetadata
{
    class Program
    {
        static void Main(string[] args)
        {
            SqlSessionProvider.Instance().SetSharedResourceProviderToUse("SharedServices1");
            NamedLobSystemInstanceDictionary sysInstances = ApplicationRegistry.GetLobSystemInstances();
            Console.WriteLine("Installed LOB System Instances:");
            foreach (String name in sysInstances.Keys)
            {
                Console.WriteLine("\t" + name);
            }

            LobSystemInstance advWorksInstance = sysInstances["AdventureWorksSampleInstance"];
            LobSystem advWorksSystem = advWorksInstance.GetLobSystem();
            Console.WriteLine("\n" + advWorksSystem.ConnectionManagerType.ToString());
            Console.WriteLine(advWorksSystem.Name.ToString());
            Console.WriteLine(advWorksSystem.Id.ToString());

            NamedEntityDictionary entities = advWorksInstance.GetEntities();
            foreach (string key in entities.Keys)
            {
                Entity entity = entities[key];
                Console.WriteLine("Entity {0}, ID {1}", key, entity.Id);                
            }


            Console.ReadLine();
        }
    }
}
