using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Office.Server.ApplicationRegistry.MetadataModel;
using Microsoft.Office.Server.ApplicationRegistry.Runtime;
using Microsoft.Office.Server.ApplicationRegistry.SystemSpecific;
using Microsoft.Office.Server.ApplicationRegistry.Infrastructure;
using Microsoft.SharePoint.Administration;
using Microsoft.Office.Server.Administration;
using System.Data;

namespace SpecificFinder
{
    class Program
    {
        static void Main(string[] args)
        {
            SqlSessionProvider.Instance().SetSharedResourceProviderToUse(
                "SharedServices1");
            NamedLobSystemInstanceDictionary sysInstances = 
                ApplicationRegistry.GetLobSystemInstances();
            LobSystemInstance advWorksInstance = 
                sysInstances["AdventureWorksSampleInstance"];
            Entity custEntity = advWorksInstance.GetEntities()["Customer"];
            
            IEntityInstance entityInstance = 
                custEntity.FindSpecific(740, advWorksInstance);
            

            Console.WriteLine("Customer Fields:");
            foreach (Field f in custEntity.GetSpecificFinderView().Fields)
                Console.WriteLine("{0}:{1}", f.Name,entityInstance[f]);

            IEntityInstanceEnumerator orderInstances =
                entityInstance.GetAssociatedInstances(
                  custEntity.GetSourceAssociations()["CustomerToSalesOrder"]);
            
            while (orderInstances.MoveNext())
            {
                foreach (Field f in orderInstances.Current.ViewDefinition.Fields)
                {
                    Console.WriteLine("\t{0}:{1}", f.Name, orderInstances.Current[f]);
                }
                Console.WriteLine();
            }
            Console.ReadLine();
        }
    }
}
