using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Office.Server.ApplicationRegistry.MetadataModel;
using Microsoft.Office.Server.ApplicationRegistry.Runtime;
using Microsoft.Office.Server.ApplicationRegistry.SystemSpecific;
using Microsoft.Office.Server.ApplicationRegistry.Infrastructure;
using Microsoft.SharePoint.Administration;
using Microsoft.Office.Server.Administration;

namespace WildcardFinder
{
    class Program
    {
        static void Main(string[] args)
        {
            SqlSessionProvider.Instance().SetSharedResourceProviderToUse("SharedServices1");
            NamedLobSystemInstanceDictionary sysInstances = 
                ApplicationRegistry.GetLobSystemInstances();
            LobSystemInstance advWorksInstance = 
                sysInstances["AdventureWorksSampleInstance"];
            Entity custEntity = advWorksInstance.GetEntities()["Customer"];
            FilterCollection fc = custEntity.GetFinderFilters();
            FilterBase nameFilter = fc[1]; // ID is 0, Name is 1

            FilterCollection newfc = new FilterCollection();
            newfc.Add(nameFilter);
            ((WildcardFilter)newfc[0]).Value = "Aaron%";

            IEntityInstanceEnumerator custEntityInstanceEnumerator = 
                custEntity.FindFiltered(newfc, advWorksInstance);
            while (custEntityInstanceEnumerator.MoveNext())
            {
                IEntityInstance entityInstance = custEntityInstanceEnumerator.Current;
                foreach (Field f in custEntity.GetFinderView().Fields)
                    Console.Write("{0} ", entityInstance[f]);
                Console.WriteLine("");
            }
            Console.ReadLine();
 
        }
    }
}
