using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using Microsoft.SharePoint;
using Microsoft.SharePoint.Administration;
using System.Windows.Forms;

namespace FeatureEnumerator
{
    public partial class Form1 : Form
    {
        private SPSite _rootCollection;

        public Form1()
        {
            InitializeComponent();            

        }

        private string GetFeatureEnabled(SPFeatureDefinition featureDefinition)
        {
            foreach (SPFeature feature in _rootCollection.Features)
            {
                if (feature.Definition.Id == featureDefinition.Id)
                {
                    System.Diagnostics.Debug.WriteLine("feature properties : " + feature.Properties.Count.ToString());
                    if (feature.Properties.Count > 0)
                    {                        
                        foreach (SPFeatureProperty featureProperty in feature.Properties)
                        {
                            System.Diagnostics.Debug.WriteLine("  --" + featureProperty.Name + " : " +
                                featureProperty.Value);
                        }
                    }
                    return "Yes";
                }
            }
            return "No";
        }

        private void button1_Click(object sender, EventArgs e)
        {
            featureList.Enabled = true;
            featureList.Items.Clear();

            string dbConn = @"server=localhost\OfficeServers;initial catalog=SharePoint_Config_66140120-a9bf-4191-86b6-ec21810ca019;Integrated Security=SSPI;";
            
            _rootCollection = new SPSite(siteUrl.Text);
            SPFarm farm = SPFarm.Open(dbConn);                        
               
            statusLabel.Text = "Site Feature Status (" + farm.FeatureDefinitions.Count.ToString() + " Feature Definitions Installed)";
            foreach (SPFeatureDefinition featureDefinition in farm.FeatureDefinitions)
            {
                System.Diagnostics.Debug.WriteLine(featureDefinition.DisplayName + " : " + featureDefinition.Properties.Count.ToString());
                ListViewItem lvi = new ListViewItem(featureDefinition.DisplayName);
                if (featureDefinition.Hidden)
                    lvi.ForeColor = Color.Gray;
                lvi.Tag = featureDefinition.Id;
                lvi.SubItems.Add(GetFeatureEnabled(featureDefinition));
                featureList.Items.Add(lvi);
            }
        }

    }
}