using System;
using System.IO;
using System.Collections.Generic;
using System.Text;
using Microsoft.SharePoint;

namespace EventLogger
{
    public class ListEventLogger : SPItemEventReceiver
    {
        public override void ItemAdded(SPItemEventProperties properties)
        {
            WriteTextToLog(string.Format("[{0}] Item Added : {1}", properties.ListItem.Title, DateTime.Now.ToString()));
        }

        public override void ItemDeleted(SPItemEventProperties properties)
        {
            WriteTextToLog(string.Format("[{0}] Item Deleted : {1}", properties.ListItem.Title, DateTime.Now.ToString()));
        }

        public override void ItemUpdated(SPItemEventProperties properties)
        {
            WriteTextToLog(string.Format("[{0}] Item Updated : {1}", properties.ListItem.Title, DateTime.Now.ToString()));
        }

        private void WriteTextToLog(string text)
        {
            StreamWriter logFile = File.AppendText(@"C:\listlog.txt");
            logFile.Write(text + "\n");
            logFile.Close();
        }
    }
}
