using System;
using System.IO;
using System.Collections.Generic;
using System.Text;
using Microsoft.SharePoint;

namespace ListMetaLogger
{
    public class ListMetaLogger : SPListEventReceiver
    {
        public override void FieldAdded(SPListEventProperties properties)
        {
            LogEvent(properties, "FieldAdded");
        }

        public override void FieldAdding(SPListEventProperties properties)
        {
            LogEvent(properties, "FieldAdding");
        }

        public override void FieldDeleting(SPListEventProperties properties)
        {
            LogEvent(properties, "FieldDeleting");
        }

        public override void FieldDeleted(SPListEventProperties properties)
        {
            LogEvent(properties, "FieldDeleted");
        }

        public override void FieldUpdated(SPListEventProperties properties)
        {
            LogEvent(properties, "FieldUpdated");
        }

        public override void FieldUpdating(SPListEventProperties properties)
        {
            LogEvent(properties, "FieldUpdating");
        }

        private void LogEvent(SPListEventProperties properties, string eventName)
        {
            StreamWriter sw = File.AppendText(@"C:\listeventlog.txt");
            StringBuilder sb = new StringBuilder();
            sb.AppendFormat("[{0}] {1} Event Occurred:\n",
                DateTime.Now.ToString(), eventName);
            sb.AppendFormat("\tList : {0}", properties.ListTitle);
            sb.AppendFormat("\t{0} - Field {1}",
                properties.EventType.ToString(), properties.FieldName);

            sw.WriteLine(sb.ToString());
            sw.Close();
        }
    }
}
