using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Office.Server;
using Microsoft.Office.Server.Administration;
using Microsoft.Office.Server.UserProfiles;
using Microsoft.SharePoint;
using System.Web;

namespace EnumProfileProperties
{
    class Program
    {
        static void Main(string[] args)
        {
            using ( SPSite site = new SPSite("http://win2k3r2lab"))            
            {
                ServerContext context = ServerContext.GetContext(site);
                UserProfileManager profileManager = 
                    new UserProfileManager(context);

                UserProfile bob = profileManager.GetUserProfile(@"win2k3r2lab\bjohnson");
                Console.WriteLine("Profile {0}", bob.MultiloginAccounts[0]);
                foreach (Property prop in profileManager.Properties)
                {
                    Console.WriteLine("\t{0} : {1}",
                        prop.DisplayName,
                        RenderProperty(bob, prop));
                }

                Console.ReadLine();
            }
        }

        static string RenderProperty(UserProfile profile, Property prop)
        {
            UserProfileValueCollection values = profile[prop.Name];            
            if (values.Value == null)
                return "(NULL)";
            if (prop.IsMultivalued)
            {
                StringBuilder sb = new StringBuilder();
                foreach (object o in values)
                {
                    sb.AppendFormat("{0} ", o);
                }
                return sb.ToString();
            }
            else
            {
                return values.ToString();
            }
        }
    }
}
