using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Office.Server;
using Microsoft.Office.Server.Administration;
using Microsoft.Office.Server.UserProfiles;
using Microsoft.SharePoint;
using System.Web;

namespace UserProfilesApp
{
    class Program
    {
        static void Main(string[] args)
        {

            using (SPSite site = new SPSite("http://win2k3r2lab"))
            {
                ServerContext context =
                    ServerContext.GetContext(site);
                UserProfileManager profileManager = new UserProfileManager(context);

                string userName = @"win2k3r2lab\Administrator";
                Console.WriteLine("All Profiles:");
                foreach (UserProfile p in profileManager)
                {
                    Console.WriteLine("{0} : {1}", p.ID, p.MultiloginAccounts[0]);
                }
                Console.WriteLine("--");
                if (profileManager.UserExists(userName))
                {
                    UserProfile profile = profileManager.GetUserProfile(userName);                 
                    Console.WriteLine("Found User Profile {0}", profile.ID);
                    Console.WriteLine("\tPersonal Site: {0} ({1})", 
                        profile.PersonalSite.RootWeb.Title,
                        profile.PersonalSite.Url);                  
                }
                else
                {
                    Console.WriteLine("No account found for " + userName);
                }

                Console.ReadLine();

            }
        }

    }
}
