using System;
using System.Collections.Generic;
using System.Text;
using EntityMethods.win2k3r2lab;

namespace EntityMethods
{
    class Program
    {
        static void Main(string[] args)
        {
            BdcWebService bdc = new BdcWebService();
            bdc.Credentials = System.Net.CredentialCache.DefaultCredentials;

            EntityStruct[] entities = bdc.GetEntitiesForLobSystemInstance(340);
            foreach (EntityStruct entity in entities)
            {
                MethodStruct[] methods = bdc.GetMethodsForEntity(entity.id);
                Console.WriteLine("Entity: {0}", entity.name);
                foreach (MethodStruct method in methods)
                {
                    Console.WriteLine("\tMethod {0} : {1}", method.id, method.name);
                }
                MethodInstanceStruct[] methodInstances =
                    bdc.GetMethodInstancesForEntity(entity.id);
                foreach (MethodInstanceStruct methodInstance in methodInstances)
                {
                    Console.WriteLine("\tMethod Instance {0} : {1}", methodInstance.id,
                        methodInstance.name);
                }                
            }            

            Console.ReadLine();
        }
    }
}
