using System;
using System.Collections.Generic;
using System.Text;
using FieldResolver.win2k3r2lab;

namespace FieldResolver
{
    class Program
    {
        static void Main(string[] args)
        {
            BDCFieldsResolver resolver = new BDCFieldsResolver();
            resolver.Credentials = System.Net.CredentialCache.DefaultCredentials;

            ResolveResult result = resolver.Resolve(
                "AdventureWorksSampleInstance",
                "Customer", "1", "FirstName:LastName");                   
              
            Console.WriteLine(result.Status.ToString());
            if (result.Status == ResolveStatus.MultipleMatch ||
                result.Status == ResolveStatus.UniqueMatch)
            {                
                foreach (FieldRecord fr in result.Results)
                {
                    Console.WriteLine("{0}:{1}", fr.FieldName,
                        fr.Value);
                }
            }

            result = resolver.Resolve(
                "AdventureWorksSampleInstance",
                "Product",
                "12",
                "Name:ListPrice:ProductNumber");
            Console.WriteLine();
            Console.WriteLine(result.Status.ToString());
            if (result.Status == ResolveStatus.MultipleMatch ||
                result.Status == ResolveStatus.UniqueMatch)
            {
                foreach (FieldRecord fr in result.Results)
                {                 
                    Console.WriteLine("{0}:{1}", fr.FieldName, 
                        fr.Value);
                }
            }

            Console.ReadLine();
            
        }
    }
}
