using System;
using System.Xml;
using System.Net;
using System.Collections.Generic;
using System.Text;

namespace DocFind
{
    class Program
    {
        static void Main(string[] args)
        {
            localhost.Dws dws = new localhost.Dws();
            dws.Credentials = System.Net.CredentialCache.DefaultCredentials;

            string modifiedUrl = dws.CanCreateDwsUrl("Budget Test Site");
            Console.WriteLine(modifiedUrl);
            Guid newDocGuid = Guid.NewGuid();
            
            string documents = "<Documents><item ID=\"" + newDocGuid.ToString() + "\" Name=\"" +
                "BudgetDocument.docx\"/></Documents>";
            string result = dws.CreateDws(string.Empty, string.Empty, "Budget Test Site", documents);
            XmlDocument doc = new XmlDocument();
            doc.LoadXml(result);

            string docLibUrl = doc.SelectSingleNode("//DoclibUrl").InnerText;
            Console.WriteLine("DWS Created. Doclib URL: {0}",
                docLibUrl);

            // attach to the DWS Web Service of the newly created wbsite
            XmlDocument doc2 = new XmlDocument();
            doc2.LoadXml(modifiedUrl);
            string newUrl = doc2.SelectSingleNode("//Result").InnerText;
            dws.Url = "http://localhost/" + newUrl + "/_vti_bin/dws.asmx";
            string docLocation = dws.FindDwsDoc(newDocGuid.ToString());

            XmlDocument doc3 = new XmlDocument();
            doc3.LoadXml(docLocation);
            Console.WriteLine("Document with ID " + newDocGuid.ToString() + " can be found at " +
                doc3.SelectSingleNode("//Result").InnerText);

            Console.ReadLine();
        }
    }
}
