using System;
using System.Xml;
using System.Collections.Generic;
using System.Text;

namespace DwsData
{
    class Program
    {
        static void Main(string[] args)
        {
            localhost.Dws docWs = new DwsData.localhost.Dws();
            docWs.Url = "http://localhost/Budget/_vti_bin/dws.asmx";
            docWs.Credentials = System.Net.CredentialCache.DefaultCredentials;

            string response = docWs.GetDwsData("budget.docx", string.Empty);            
            XmlDocument doc = new XmlDocument();
            doc.LoadXml(response);            
            Console.WriteLine("Title: {0}", doc.SelectSingleNode("//Title").InnerText);
            Console.WriteLine("Last Update: {0}", doc.SelectSingleNode("//LastUpdate").InnerText);
            Console.WriteLine("User: {0} / E-Mail : {1}",
                doc.SelectSingleNode("//User/Name").InnerText,
                doc.SelectSingleNode("//User/Email").InnerText);
            Console.WriteLine("Assignees:");
            foreach (XmlNode assigneeNode in doc.SelectNodes("//Assignees/Member"))
            {
                Console.WriteLine("\t{0}", assigneeNode.SelectSingleNode("Name").InnerText);
            }
            Console.WriteLine("Members:");
            foreach (XmlNode memberNode in doc.SelectNodes("//Members/Member"))
            {
                Console.WriteLine("\t{0}", memberNode.SelectSingleNode("Name").InnerText);
            }

            Console.WriteLine("Lists:");
            foreach (XmlNode listNode in doc.SelectNodes("//List"))
            {
                // if the list exists...
                if (listNode.SelectNodes("ID").Count > 0)
                {
                    Console.WriteLine("\t{0}", listNode.SelectSingleNode("ID").InnerText);
                }
            }
            
            Console.ReadLine();
        }
    }
}
