using System;
using System.Collections.Generic;
using System.Text;

namespace DwsToolsLib
{
    /// <summary>
    /// Utility functions taken from the SharePoint 2007 SDK
    /// </summary>
    public class DwsTools
    {
        public static bool IsDwsErrorResult(string ResultFragment)
        {
            System.IO.StringReader srResult =
                new System.IO.StringReader(ResultFragment);
            System.Xml.XmlTextReader xtr =
                new System.Xml.XmlTextReader(srResult);
            xtr.Read();
            if (xtr.Name == "Error")
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        public static void ParseDwsErrorResult(string ErrorFragment, out int ErrorID,
            out string ErrorMsg)
        {
            System.IO.StringReader srError =
                new System.IO.StringReader(ErrorFragment);
            System.Xml.XmlTextReader xtr =
                new System.Xml.XmlTextReader(srError);
            xtr.Read();
            xtr.MoveToAttribute("ID");
            xtr.ReadAttributeValue();
            ErrorID = System.Convert.ToInt32(xtr.Value);
            ErrorMsg = xtr.ReadString();
        }

        public static string ParseDwsSingleResult(string ResultFragment)
        {
            System.IO.StringReader srResult =
                new System.IO.StringReader(ResultFragment);
            System.Xml.XmlTextReader xtr =
                new System.Xml.XmlTextReader(srResult);
            xtr.Read();
            return xtr.ReadString();
        }

    }
}
