using System;
using System.Collections.Generic;
using System.Text;
using MileageExpenseClient.excelService;
using System.IO;


namespace MileageExpenseClient
{
    class Program
    {
        static void Main(string[] args)
        {
            excelService.ExcelService ews = new ExcelService();
            ews.Credentials = new System.Net.NetworkCredential("Administrator", 
                "password");

            // open the workbook
            Status[] stati;

            string sessionId = 
                ews.OpenWorkbook("http://win2k3r2lab/Excel Files/mileage_expense.xlsx",
                "en-US", "en-US", out stati);

            // set the range of values for the mileage travelled
            object[] rangeValues = new object[] { new object[] { 15 },
                new object[] { 9 },
                new object[] { 21 },
                new object[] { 18 },
                new object[] { 35 },
                new object[] { 72 },
                new object[] { 64 },
                new object[] { 90 },
                new object[] { 13 },
                new object[] { 18 },
                new object[] { 21 },
                new object[] { 30 },
                new object[] { 91 },
                new object[] { 15 },
                new object[] { 21 },
            };
            stati = ews.SetRangeA1(sessionId, "Sheet1", "MileageValues",
                    rangeValues);

            // now take a look at the total calculated compensation for mileage travelled.
            object[] totalPaybackRows = 
                ews.GetRangeA1(sessionId, "Sheet1", "TotalPayback", false, out stati);
            object[] totalPayback = (object[])totalPaybackRows[0];

            byte[] workbookBytes = 
                ews.GetWorkbook(sessionId, WorkbookType.FullSnapshot, out stati);

            FileStream fs = new FileStream("MileageExpenseSnapshot.xlsx", FileMode.Create);
            fs.Write(workbookBytes, 0, workbookBytes.Length);
            fs.Close();
            
            Console.WriteLine("Total amount due employee : {0:C}", (double)totalPayback[0]);
            Console.ReadLine();
        }
    }
}
