using System;
using System.IO;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace PhotoBrowser
{
    public partial class PhotoDetail : Form
    {
        private DataRow photoRow = null;

        public PhotoDetail(DataRow row, byte[] fileBytes)
        {
            InitializeComponent();
            string fileRef = (string)row["ows_FileRef"];
            string[] fileRefs = fileRef.Split(';');
            string fileName = fileRefs[1].Substring(1, fileRefs[1].Length - 1);
            fileName = Path.GetFileName(fileName);

            this.Text = fileName;

            photoRow = row;
            largePicture.Image = Image.FromStream(new MemoryStream(fileBytes));
            

            pictureTitle.Text = photoRow["ows_Title"] == DBNull.Value ? "(untitled)" : (string)photoRow["ows_Title"];
            pictureDescription.Text = photoRow["ows_Description"] == DBNull.Value ? "(no description)" : (string)photoRow["ows_Description"];
        }

        private void confirmButton_Click(object sender, EventArgs e)
        {
            this.Close();
        }
    }
}