using System;
using System.Xml;
using System.Collections.Generic;
using System.Text;

namespace HierarchyDemo
{
    class Program
    {
        static void Main(string[] args)
        {
            win2k3r2lab.Lists listService = new HierarchyDemo.win2k3r2lab.Lists();
            listService.Credentials = new System.Net.NetworkCredential("Administrator", "password");
            XmlDocument doc = new XmlDocument();

            XmlNode viewFieldsParent = doc.CreateElement("ViewFields");
            viewFieldsParent.InnerXml =
                "<FieldRef Name=\"ID\"/>" +
                "<FieldRef Name=\"Order_x0020_Number\"/>";

            XmlNode listItems = listService.GetListItems("Hierarchy Demo", "", null, viewFieldsParent, "0", null, "");
            
            foreach (XmlNode item in listItems.SelectNodes("//*[local-name()='row']"))
            {
                Console.WriteLine("Order: " + item.Attributes.GetNamedItem("ows_Title").Value);
                Console.WriteLine("Order #: " + item.Attributes.GetNamedItem("ows_Order_x0020_Number").Value);
                
                string folderName = item.Attributes.GetNamedItem("ows_Title").Value;
                XmlNode queryOptions = doc.CreateElement("QueryOptions");
                queryOptions.InnerXml =
                    "<Folder>" + folderName + "</Folder>";
                XmlNode viewFields = doc.CreateElement("ViewFields");
                viewFields.InnerXml =
                    "<FieldRef Name=\"ID\"/>" +
                    "<FieldRef Name=\"OrderItem\"/>" +
                    "<FieldRef Name=\"SKU\"/>";
                XmlNode subItems = listService.GetListItems("Hierarchy Demo", "", null, viewFields, "0", queryOptions, "");
            
                int x = 0;
                foreach (XmlNode subItem in subItems.SelectNodes("//*[local-name()='row']"))
                {
                    if (x > 0)
                    { // skip the first row, since thats the containing folder
                        Console.WriteLine(
                            string.Format("\tItem {0}: {1}",
                            subItem.Attributes.GetNamedItem("ows_OrderItem").Value,
                            subItem.Attributes.GetNamedItem("ows_Title").Value));
                        Console.WriteLine("\tSKU: " + subItem.Attributes.GetNamedItem("ows_SKU").Value);
                    }
                    x++;
                }

                
            }
            Console.ReadLine();
        }
    }
}
