using System;
using System.Xml;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace ListRetriever
{
    public partial class Form1 : Form
    {
        private win2k3r2lab.Lists listService = null;

        public Form1()
        {
            InitializeComponent();
        }

        private void retrieveListsButton_Click(object sender, EventArgs e)
        {
            listService = new ListRetriever.win2k3r2lab.Lists();
            listService.Credentials = new System.Net.NetworkCredential("Administrator", "password");
            listService.Url = siteUrl.Text;

            XmlNode listCollection = listService.GetListCollection();
            siteLists.Items.Clear();
            MessageBox.Show(listCollection.ChildNodes[0].OuterXml);
            foreach (XmlNode listNode in listCollection.ChildNodes)
            {
                ListViewItem lvi = new ListViewItem();
                lvi.Text = listNode.Attributes.GetNamedItem("Title").Value;
                lvi.Tag = listNode.Attributes.GetNamedItem("ID").Value;
                lvi.SubItems.Add(listNode.Attributes.GetNamedItem("ServerTemplate").Value);
                siteLists.Items.Add(lvi);
            }
        }

        private void siteLists_SelectedIndexChanged(object sender, EventArgs e)
        {
            titleList.Items.Clear();

            if (siteLists.SelectedItems.Count == 0) return;
            
            string listGuid = (string)siteLists.SelectedItems[0].Tag;

            XmlNode itemCollection = listService.GetListItems(
                listGuid, string.Empty, null, null, "0", null, string.Empty);

            foreach (XmlNode item in itemCollection.SelectNodes("//*[local-name()='row']"))
            {
                titleList.Items.Add(item.Attributes.GetNamedItem("ows_Title") == null ? "No title" :
                    item.Attributes.GetNamedItem("ows_Title").Value);
            }
        }
    }
}