using System;
using System.Xml;
using System.Collections.Generic;
using System.Text;

namespace ListUpdater
{
    class Program
    {
        static void Main(string[] args)
        {
            // if you're renaming a list, use the GUID to be consistent.
            string listGuid = "{3DE6337E-7E49-4AD6-9936-8440C20F7711}";
            win2k3r2lab.Lists listService = new ListUpdater.win2k3r2lab.Lists();
            listService.Url = "http://win2k3r2lab/sitedirectory/research/_vti_bin/Lists.asmx";
            listService.Credentials = new System.Net.NetworkCredential("Administrator", "password");

            XmlDocument doc = new XmlDocument();
            // list properties
            XmlElement properties = doc.CreateElement("List");
            properties.SetAttribute("Title", "Updated List Title");
            properties.SetAttribute("Description", "Updated List Description");

            // new fields (first name, last name, and 'fullname' calculated readonly column            
            XmlElement newFields = doc.CreateElement("Fields");
            XmlElement newMethod = doc.CreateElement("Method");
            newFields.AppendChild(newMethod);
            newMethod.SetAttribute("ID", "1");
            XmlElement newField = doc.CreateElement("Field");
            newMethod.AppendChild(newField);
            newField.SetAttribute("ReadOnly", "FALSE");
            newField.SetAttribute("DisplayName", "First Name");
            newField.SetAttribute("Name", "FirstName");
            newField.SetAttribute("Type", "Text");
            newField.SetAttribute("FromBaseType", "TRUE");            

            // last name
            newMethod = doc.CreateElement("Method");
            newMethod.SetAttribute("ID", "2");
            newField = doc.CreateElement("Field");
            newField.SetAttribute("ReadOnly", "FALSE");
            newField.SetAttribute("DisplayName", "Last Name");
            newField.SetAttribute("Name", "LastName");
            newField.SetAttribute("Type", "Text");
            newField.SetAttribute("FromBaseType", "TRUE");
            newMethod.AppendChild(newField);
            newFields.AppendChild(newMethod);
            
                      
            //listService.UpdateList(listGuid, (XmlNode)properties, (XmlNode)newFields, null, null, string.Empty);
            Console.WriteLine("List modified once");

            // full name
            newFields = doc.CreateElement("Fields");            
            newField = doc.CreateElement("Field");
            newFields.AppendChild(newField);
            newMethod = doc.CreateElement("Method");
            newMethod.SetAttribute("ID", "3");            
            newField.SetAttribute("ReadOnly", "TRUE");
            newField.SetAttribute("DisplayName", "Full Name");
            newField.SetAttribute("Name", "FullName");
            newField.SetAttribute("Type", "Calculated");
            newField.SetAttribute("ResultType", "Text");
            
            newMethod.AppendChild(newField);
            XmlElement formula = doc.CreateElement("Formula");
            formula.InnerText = "=[Last Name]&\", \"&[First Name]";
            XmlElement formulaDisplayNames = doc.CreateElement("FormulaDisplayNames");
            formulaDisplayNames.InnerText = "=[Last Name]&[First Name]";
            newField.AppendChild(formula);
            newField.AppendChild(formulaDisplayNames);
            XmlElement fieldRefs = doc.CreateElement("FieldRefs");
            fieldRefs.InnerXml = "<FieldRef Name='First Name'/><FieldRef Name='Last Name'/>";
            newField.AppendChild(fieldRefs);
            newFields.AppendChild(newMethod);

            Console.WriteLine(newFields.OuterXml);

            listService.UpdateList(listGuid, null, (XmlNode)newFields, null, null, string.Empty);

            Console.ReadLine();
        }
    }
}
