using System;
using System.Xml;
using System.Collections.Generic;
using System.Text;

namespace RevisionControl
{
    class Program
    {
        static void Main(string[] args)
        {
            win2k3r2lab.Lists listService = new RevisionControl.win2k3r2lab.Lists();
            listService.Credentials = new System.Net.NetworkCredential("Administrator", "password");
            listService.Url = "http://win2k3r2lab/sitedirectory/research/_vti_bin/lists.asmx";

            XmlNode versions = listService.GetVersionCollection("Updated List Title", "4", "Title");
            Console.WriteLine(versions.OuterXml);

            XmlNode listItemChanges = listService.GetListItemChanges("Updated List Title", null, DateTime.Now.AddYears(-1).ToUniversalTime().ToString(), null);
            Console.WriteLine(listItemChanges.OuterXml);
            foreach (XmlNode item in listItemChanges.SelectNodes("//*[local-name()='row']"))
            {
                Console.WriteLine(
                    string.Format("{0} v{1} : {2}", item.Attributes.GetNamedItem("ows_ID").Value,
                        item.Attributes.GetNamedItem("ows_owshiddenversion").Value,
                        item.Attributes.GetNamedItem("ows_Title") == null ? "(no title)" :
                            item.Attributes.GetNamedItem("ows_Title").Value));
            }
            
            Console.ReadLine();                        
        }
    }
}
