using System;
using System.Xml;
using System.Xml.Serialization;
using System.Collections.Generic;
using System.Text;

namespace SAMS.SharePoint.Tools.ListLibrary
{
    public class RowHeader<T> where T : StandardListItem
    {
        private int _itemCount = 0;        
        private List<T> _listItems;

        public RowHeader()
        {
            _listItems = new List<T>();
        }

        public void AddItem(T newItem)
        {
            _listItems.Add(newItem);
            newItem.BatchMode = BatchMode.New;
        }

        [XmlAttribute("ItemCount")]
        public int ItemCount
        {
            get
            {
                return _itemCount;
            }
            set
            {
                _itemCount = value;
            }
        }

        [XmlElement(ElementName = "row", Namespace = "#RowsetSchema")]        
        public List<T> ListItems
        {
            get
            {
                return _listItems;
            }
            set
            {
                _listItems = value;
            }
        }

    }
}


