using System;
using System.Xml;
using System.Xml.Serialization;
using System.Collections.Generic;
using System.Text;

namespace SAMS.SharePoint.Tools.ListLibrary
{
    public class TaskListItem : StandardListItem
    {
        private string _priority;
        private string _status;
        private string _assignedTo;
        private string _description;
        private string _startDate;
        private string _dueDate;
        private decimal _percentComplete = 0;

        [XmlAttribute("ows_Priority")]
        
        public string Priority
        {
            get { return _priority; }
            set
            {
                _priority = value;
                NotifyPropertyChanged("Priority");
            }
        }

        [XmlAttribute("ows_Status")]
        
        public string Status
        {
            get { return _status; }
            set
            {
                _status = value;
                NotifyPropertyChanged("Status");
            }
        }

        [XmlAttribute("ows_AssignedTo")]
        
        public string AssignedTo
        {
            get { return _assignedTo; }
            set
            {
                _assignedTo = value;
                NotifyPropertyChanged("AssignedTo");
            }
        }

        [XmlAttribute("ows_Body")]
        
        public string Description
        {
            get { return _description; }
            set
            {
                _description = value;
                NotifyPropertyChanged("Description");
            }
        }

        [XmlAttribute("ows_StartDate")]
        public string RawStartDate
        {
            get { return _startDate; }
            set
            {
                _startDate = value;
                NotifyPropertyChanged("RawStartDate");
            }
        }

        [XmlAttribute("ows_DueDate")]
        public string RawDueDate
        {
            get { return _dueDate; }
            set { 
                _dueDate = value;
                NotifyPropertyChanged("RawDueDate");
            }
        }

        [XmlAttribute("ows_PercentComplete")]
        public decimal PercentComplete
        {
            get { return _percentComplete; }
            set
            {
                _percentComplete = value;
                NotifyPropertyChanged("PercentComplete");
            }
        }

        public string AssignedToName
        {
            get { return ListItems<TaskListItem>.GetDescriptionFromLookupValue(_assignedTo); }
        }

        public DateTime StartDate
        {
            get { return DateTime.Parse(_startDate); }
        }

        public DateTime DueDate
        {
            get { return DateTime.Parse(_dueDate); }
        }
    }
}
