using System;
using System.Xml;
using System.Collections.Generic;
using System.Text;
using SAMS.SharePoint.Tools.ListLibrary;

namespace ListTester
{
    class Program
    {
        static void Main(string[] args)
        {            
            research.Lists lists = new research.Lists();
            lists.Url = "http://win2k3r2lab/sitedirectory/research/_vti_bin/lists.asmx";
            lists.Credentials = new System.Net.NetworkCredential("Administrator", "password");
            XmlDocument doc = new XmlDocument();
            XmlNode queryNode = doc.CreateElement("Query");
            XmlNode fieldsNode = doc.CreateElement("ViewFields");
            XmlNode optionsNode = doc.CreateElement("QueryOptions");

            XmlNode rawItems = lists.GetListItems(
                "Tasks", string.Empty, queryNode, fieldsNode, "9999", optionsNode, "");

            ListItems<TaskListItem> taskList = ListItems<TaskListItem>.FromXml(rawItems.OuterXml);
            Console.WriteLine("Found " + taskList.RowHeader.ItemCount.ToString() + " items.");

            foreach (TaskListItem task in taskList.RowHeader.ListItems)
            {
                Console.WriteLine(
                    string.Format("Task '{0}' is assigned to {1} : {2:P} complete.",
                        task.Title, task.AssignedToName, task.PercentComplete));
                Console.WriteLine(
                    string.Format("Task starts on {0} and is due on {1}.",
                    task.StartDate, task.DueDate));
                Console.WriteLine("---");
            }
            taskList.TrackChanges();
            //Console.WriteLine(taskList.GetBatchUpdateNode().OuterXml);
            taskList.RowHeader.ListItems[0].Title = "modified";            

            /*TaskListItem tli = new TaskListItem();
            tli.Title = "Recently added";
            taskList.RowHeader.AddItem(tli); */
            Console.WriteLine(taskList.GetBatchUpdateNode().OuterXml);
            XmlNode resultsNode = lists.UpdateListItems("Tasks", taskList.GetBatchUpdateNode());
            Console.WriteLine(resultsNode.OuterXml);



            //Console.WriteLine(rawItems.OuterXml);
            Console.ReadLine();
        }
    }
}
