using System;
using System.Xml;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace WorkspaceManager
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {            
            /*research.Meetings meetingWs = new research.Meetings();
            meetingWs.Credentials = new System.Net.NetworkCredential("Administrator", "password");
            XmlNode node = meetingWs.CreateWorkspace("Test Workspace", "Test", 1033, new WorkspaceManager.research.TimeZoneInf());
            MessageBox.Show(node.OuterXml); */
        }

        private void button1_Click(object sender, EventArgs e)
        {
            research.Meetings meetingWs = new research.Meetings();            
            meetingWs.Credentials = new System.Net.NetworkCredential("Administrator", "password");
            meetingWs.Url = parentsiteUrl.Text;
            XmlNode resultsNode = meetingWs.GetMeetingWorkspaces(false);
            workspaceList.Items.Clear();

            foreach (XmlNode workspaceNode in resultsNode.ChildNodes)
            {
                ListViewItem lvi = new ListViewItem();
                lvi.Text = workspaceNode.Attributes["Title"].Value;
                lvi.SubItems.Add(workspaceNode.Attributes["Url"].Value);
                workspaceList.Items.Add(lvi);
            }                        
        }

        private void newWorkspaceButton_Click(object sender, EventArgs e)
        {
            research.Meetings meetingsWs = new WorkspaceManager.research.Meetings();
            meetingsWs.Credentials = new System.Net.NetworkCredential("Administrator", "password");
            meetingsWs.Url = parentsiteUrl.Text;

            research.TimeZoneInf tzi = new WorkspaceManager.research.TimeZoneInf();
            // modify timezone data as you see fit..
            XmlNode results = meetingsWs.CreateWorkspace("New Workspace", "MPS#0", 1033,
                tzi);
            MessageBox.Show("New workspace created. Re-load Workspaces to see new workspace.");
        }

        private void deleteWorkspaceButton_Click(object sender, EventArgs e)
        {
            if (workspaceList.SelectedItems.Count == 0) return;

            ListViewItem selectedWorkspace = workspaceList.SelectedItems[0];
            if (selectedWorkspace != null)
            {
                if (MessageBox.Show("Are you sure you want to delete this workspace?",
                    "Delete Workspace", MessageBoxButtons.YesNo) == DialogResult.Yes)
                {

                    research.Meetings meetingsWs = new WorkspaceManager.research.Meetings();
                    meetingsWs.Credentials = new System.Net.NetworkCredential("Administrator", "password");
                    meetingsWs.Url = selectedWorkspace.SubItems[1].Text + "/_vti_bin/meetings.asmx";

                    meetingsWs.DeleteWorkspace();
                    selectedWorkspace.Remove();
                    MessageBox.Show("Workspace deleted.");
                }
            }
        }

        private void renameWorkspaceButton_Click(object sender, EventArgs e)
        {
            if (workspaceList.SelectedItems.Count == 0) return;

            ListViewItem selectedWorkspace = workspaceList.SelectedItems[0];
            if (selectedWorkspace != null)
            {
                research.Meetings meetingsWs = new WorkspaceManager.research.Meetings();
                meetingsWs.Credentials = new System.Net.NetworkCredential("Administrator", "password");
                meetingsWs.Url = selectedWorkspace.SubItems[1].Text + "/_vti_bin/meetings.asmx";
                meetingsWs.SetWorkspaceTitle(renameTitle.Text);
                selectedWorkspace.Text = renameTitle.Text;                
            }
        }

        private void addMeetingToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (workspaceList.SelectedItems.Count == 0) return;

            ListViewItem selectedWorkspace = workspaceList.SelectedItems[0];

            MeetingDetails newMeeting = new MeetingDetails();
            newMeeting.Text = "New Meeting"; 

            if (newMeeting.ShowDialog() == DialogResult.OK)
            {
                // create new meeting, confirmed.

                research.Meetings meetingsWs = new WorkspaceManager.research.Meetings();
                meetingsWs.Credentials = new System.Net.NetworkCredential("Administrator", "password");
                meetingsWs.Url = selectedWorkspace.SubItems[1].Text + "/_vti_bin/meetings.asmx";
                meetingsWs.AddMeeting(
                    "",
                    System.Guid.NewGuid().ToString(),
                    0,
                    DateTime.Now.ToUniversalTime(),
                    newMeeting.Title,
                    newMeeting.Location,
                    newMeeting.StartDate.ToUniversalTime(),
                    newMeeting.EndDate.ToUniversalTime(), false);
            }
        }

        private void meetingInfoToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (workspaceList.SelectedItems.Count == 0) return;

            ListViewItem selectedWorkspace = workspaceList.SelectedItems[0];

            research.Meetings meetingsWs = new WorkspaceManager.research.Meetings();
            meetingsWs.Credentials = new System.Net.NetworkCredential("Administrator", "password");
            meetingsWs.Url = selectedWorkspace.SubItems[1].Text + "/_vti_bin/meetings.asmx";

            XmlNode node = meetingsWs.GetMeetingsInformation(0, 1033);

        }

        private void workspaceList_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (workspaceList.SelectedItems.Count == 0) return;

            ListViewItem selectedWorkspace = workspaceList.SelectedItems[0];

            XmlDocument doc = new XmlDocument();
            XmlNode queryNode = doc.CreateElement("Query");
            XmlNode viewfieldsNode = doc.CreateElement("ViewFields");
            XmlNode queryOptionsNode = doc.CreateElement("QueryOptions");
            researchLists.Lists lists = new WorkspaceManager.researchLists.Lists();
            lists.Url = selectedWorkspace.SubItems[1].Text + "/_vti_bin/lists.asmx";            
            lists.Credentials = new System.Net.NetworkCredential("Administrator", "password");
            XmlNode results =
                lists.GetListItems("Meeting Series", "", queryNode, viewfieldsNode, "0", queryOptionsNode, "");

            meetingList.Items.Clear();
            foreach (XmlNode meeting in results.SelectNodes("//*[local-name()='row']"))
            {
                ListViewItem lvi = new ListViewItem();
                lvi.Text = meeting.Attributes.GetNamedItem("ows_Title").Value;
                lvi.SubItems.Add(meeting.Attributes.GetNamedItem("ows_Location").Value);
                lvi.SubItems.Add(meeting.Attributes.GetNamedItem("ows_EventUID").Value);
                meetingList.Items.Add(lvi);
            }
        }

        private void setAttendeeToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (workspaceList.SelectedItems.Count == 0) return;
            ListViewItem selectedWorkspace = workspaceList.SelectedItems[0];
            if (meetingList.SelectedItems.Count == 0) return;
            ListViewItem selectedMeeting = meetingList.SelectedItems[0];            

            research.Meetings meetingsWs = new WorkspaceManager.research.Meetings();
            meetingsWs.Credentials = new System.Net.NetworkCredential("Administrator", "password");
            meetingsWs.Url = selectedWorkspace.SubItems[1].Text + "/_vti_bin/meetings.asmx";

            meetingsWs.SetAttendeeResponse("someone@example.com",
                0,
                selectedMeeting.SubItems[2].Text,
                0,
                DateTime.Now.ToUniversalTime(),
                DateTime.Now.ToUniversalTime(), WorkspaceManager.research.AttendeeResponse.responseDeclined);

        }
    }
}