using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel;

namespace EnumUsersAndGroups
{
    public class SecurityUser : INotifyPropertyChanged
    {
        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        #endregion

        private string _userName;
        private string _email;

        public string UserName
        {
            get { return _userName; }
            set
            {
                _userName = value;
                NotifyChanged("UserName");
            }
        }

        public string Email
        {
            get
            {
                return _email;
            }
            set
            {
                _email = value;
                NotifyChanged("Email");
            }
        }


        private void NotifyChanged(string propName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propName));
        }
    }
}
