using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Xml;


namespace EnumUsersAndGroups
{
    /// <summary>
    /// This application populates two lists. The left-side list is a list of all
    /// groups on the site. As the user clicks a group on the left, the list of users
    /// belonging to that group is displayed on the right.
    /// </summary>

    public partial class Window1 : System.Windows.Window
    {
        private win2k3_splab.UserGroup _groupService;

        public Window1()
        {
            InitializeComponent();
            try
            {
                _groupService = new EnumUsersAndGroups.win2k3_splab.UserGroup();
                _groupService.Credentials = new System.Net.NetworkCredential("Administrator", "password");

                XmlNode groupNode = _groupService.GetGroupCollectionFromSite();
                AppModel model = new AppModel();
                foreach (XmlNode group in groupNode.ChildNodes[0].ChildNodes)
                {
                    SecurityGroup sg = new SecurityGroup();
                    sg.GroupName = group.Attributes["Name"].Value;
                    model.Groups.Add(sg);
                }
            }
            catch (Exception ex)
            {
                System.Diagnostics.Debug.WriteLine(ex.ToString());
            }
        }

        public void groupList_SelectionChanged(object sender, RoutedEventArgs e)
        {
            try
            {
                SecurityGroup sg = (SecurityGroup)groupList.SelectedItem;
                AppModel model = new AppModel();
                model.Users.Clear();
                XmlNode userNode = _groupService.GetUserCollectionFromGroup(sg.GroupName);
                System.Diagnostics.Debug.WriteLine(userNode.InnerXml);
                foreach (XmlNode user in userNode.ChildNodes[0].ChildNodes)
                {
                    SecurityUser newUser = new SecurityUser();
                    newUser.UserName = user.Attributes["Name"].Value;
                    newUser.Email = user.Attributes["Email"].Value;
                    model.Users.Add(newUser);
                }
            }
            catch (Exception ex)
            {
                System.Diagnostics.Debug.WriteLine(ex.ToString());
            }
        }

    }
}